<?php

App::uses('BuzzStaffRotasAppController', 'BuzzStaffRotas.Controller');

class StaffRotasController extends BuzzStaffRotasAppController {

	public function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow(['index', 'rota', 'generateUrl']);
	}

	/**
	 * No controller logic needed
	 * @return null
	 */
	public function index() { }

	public function rota($date, $department = null, $user = null) {
		$Model = $this->{$this->modelClass};
		$alias = $Model->alias;

		$this->loadModel('BuzzStaffRotas.StaffRotaApi');
		$records = $this->StaffRotaApi->getRotaRecords($date, $department, $user);
		$data = $records['StaffRotaApi']['d'];



		// Order the array of objects based on name attribute of each object.
		usort($data, function ($a, $b) {
			return ($a['WorkedByUser'] > $b['WorkedByUser']);
		});

		// Set the variables in the view in case they update the filters.
		$this->set(compact('data', 'date', 'department', 'user'));
	}

	/**
	 * Forms are submitted to this function. This then handles the data
	 * and builds the URL, which the user is redirected to.
	 * @return redirect array
	 */
	public function generateUrl() {
		$filters = $this->request->data['filter'];
		if (isset($filters['Date']) && !empty($filters['Date'])) {
			// Build the date in the right format.
			$date = $filters['Date'];
			if (isset($filters['Department']) && !empty($filters['Department'])) {
				$department = strtolower($filters['Department']);
			} else {
				$department = '';
			}
			if (isset($filters['Username']) && !empty($filters['Username'])) {
				$username = strtolower($filters['Username']);
			} else {
				$username = '';
			}
			return $this->redirect(
				[
					'action' => 'rota',
					$date,
					$department,
					$username
				]
			);
		} else {
			return $this->redirect(
				[
					'action' => 'index'
				]
			);
		}
	}
}
